﻿using System.Globalization;
using System.Windows;
using System.Windows.Media;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 렌더링시 처리하기 - OnRender(drawingContext)

        /// <summary>
        /// 렌더링시 처리하기
        /// </summary>
        /// <param name="drawingContext">그리기 객체</param>
        protected override void OnRender(DrawingContext drawingContext)
        {
            Rect backgroundRectangle = new Rect(0, 0, ActualWidth, ActualHeight);

            drawingContext.DrawRectangle(Brushes.White, null, backgroundRectangle);

            const double FONT_SIZE = 70;

            FontFamily fontFamily = new FontFamily("Segoe");
            Typeface   typeface   = new Typeface("Segoe");

            FormattedText formattedText = new FormattedText
            (
                "TEST STRING",
                new CultureInfo("en-us"),
                FlowDirection.LeftToRight,
                typeface,
                FONT_SIZE,
                Brushes.Black
            );

            formattedText.SetFontWeight(FontWeights.Bold);

            formattedText.TextAlignment = TextAlignment.Center;

            Point originPoint = new Point
            (
                this.mainGrid.ActualWidth / 2,
                (this.mainGrid.ActualHeight - formattedText.Height) / 2
            );

            Geometry geometry = formattedText.BuildGeometry(originPoint);

            Pen pen = new Pen(Brushes.Red, 2);

            drawingContext.DrawGeometry(Brushes.Yellow, pen, geometry);
        }

        #endregion
    }
}